#include <bits/stdc++.h>
#define int int64_t
#define fi first
#define se second

using namespace std;

int mx(int a, int b){
    if(a > b) return a;
    return b;
}

int32_t main(){
	ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

    int n, q; cin >> n >> q;
    int qc = q;

    vector<pair<int, int>> v(n);

    for(int i = 0; i < n; i++){
        cin >> v[i].fi >> v[i].se;
    }

    /*for(auto par : v){
        cout << par.fi << ' ' << par.se << '\n';
    }*/

    int ans = 0, k;
    int d = v[0].fi;
    int od = 0;
    cin >> k; q--;
    for(int i = 0; i < n; i++){
        if(d < v[i].fi) d = v[i].fi;

        if(d + v[i].se - 1 < k){
            ans += v[i].se;
            d += v[i].se;
        }
        else if(d + v[i].se - 1 == k){
            ans += v[i].se;
            d += v[i].se;
            cout << ans << '\n';
            od++;
            if(q > 0){ cin >> k; q--;}
            else return 0;
        }
        else{
            if(k-d+1 > 0){
                ans += mx(0, k - d + 1);
                v[i].se -= mx(0, k - d + 1);
                v[i].fi = k + 1;
            }
            d = k + 1;
            i--;
            cout << ans << '\n';
            od++;
            if(q > 0){ cin >> k; q--;}
            else return 0;
        }
    }

    for(int i = od; i < qc; i++){
        cout << ans << '\n';
        if(q > 0){
            cin >> k; q--;
        }
    }
	return 0;
}